// Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function number_checkpositive ( varname , value )
  //   Checks that the given value is positive.
  //
  // Calling Sequence
  //   number_checkpositive ( varname , value )
  //
  // Parameters
  //   varname : a 1x1 matrix of strings, the name of the variable
  //   value : the value of the variable
  //
  // Description
  //   Generates an error if varname is not positive.
  //
  // Examples
  // number_checkpositive ( "n" , 1 )
  //
  // // Generates an error
  // number_checkpositive ( "n" , -1 )
  //
  // Authors
  // Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin
  //

  if ( value < 0 ) then
    errmsg = sprintf ( gettext ( "%s: Number %s from %s is not positive" ) , "number_checkpositive" , string(value) , varname )
    error(errmsg)
  end
endfunction

