// Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function arecoprime = number_coprime ( m , n )
  // Checks if two numbers are relatively prime.
  // 
  // Calling Sequence
  //   arecoprime = number_coprime ( m , n )
  //
  // Parameters
  //   m : a 1x1 matrix of floating point integers, must be positive
  //   n : a 1x1 matrix of floating point integers, must be positive
  //   arecoprime : a 1x1 matrix of booleans
  //
  // Description
  //   Returns %t if the given numbers are relative primes.
  //
  // Examples
  // computed = number_coprime ( 84 , 18 ) // %f 
  // computed = number_coprime ( 17 , 19 ) // %t
  //
  // Authors
  // Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin
  //

  number_check ( m )
  number_check ( n )
  number_checkpositive ( "m" , m )
  number_checkpositive ( "n" , n )
  d = number_gcd ( m , n )
  arecoprime = ( d == 1 )
endfunction

