// Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin

// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function a = number_mersenne ( n )
  // Returns the Mersenne number 2^n - 1
  // 
  // Calling Sequence
  //   a = number_mersenne ( n )
  //
  // Parameters
  // n : a 1x1 matrix of floating point integers, must be positive
  // a : a 1x1 matrix of floating point integers
  //
  // Description
  // Returns the Mersenne number 2^n - 1.
  //
  // Examples
  // number_mersenne ( 2 ) // 3
  // number_mersenne ( 3 ) // 7
  // number_mersenne ( 5 ) // 31
  //
  // Authors
  // Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin
  //

  number_check ( n )
  number_checkpositive ( "n" , n )
  a = 2^n - 1
endfunction

