// Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

function number_startup ( )
  //   Startup the number library.
  //
  // Calling Sequence
  //
  // Parameters
  //
  // Description
  // Initialize the global variable %number, which contains 
  // configuration informations.
  // verbose= 0 if no logging is required, verbose= 1 if some logging is required.
  // Higher values of verbose may be implemented in the future
  // imax = the maximum number of iterations in the search for a divisor
  //
  // Examples
  // number_startup ( )
  //
  // Authors
  // Copyright (C) 2009 - 2010 - DIGITEO - Michael Baudin
  //

  global %number
  %number = tlist(["T_NUMBER"
    "verbose"
    "imax"
    "pollardseeds"
    ])
  %number.imax = 10000
  %number.verbose = 0
  %number.pollardseeds = [-3 1 3 5]
  // Initialize the random number generator,
  // so that results of Pollard's rho and probable primality test
  // can be reproduced.
  rand ( "seed" , 0 )
endfunction

